#ifndef	NETLIB
#define	NETLIB

#include	<windows.h>
#include	<winsock.h>

#define		RECV_BUFFER				4096

#define		NETLIB_REASON_INITIALIZE	0
#define		NETLIB_REASON_CONNECT		1
#define		NETLIB_REASON_CONNECTION_FAILED	2
#define		NETLIB_REASON_DISCONNECT	3
#define		NETLIB_REASON_DATA			4

#define		TCP_FLAG_TEXT			(1 << 0)

typedef		struct	NetLib_ConnectionStruct	NetLib_Connection;

typedef		int	(*NetLib_CallbackProc)(NetLib_Connection * conn, int reason, void * data, int len);

struct	NetLib_ConnectionStruct
{
NetLib_CallbackProc	Proc;
byte	buf[RECV_BUFFER+1];
int		buf_pos;
DWORD	flags;
SOCKET	sock;
int		active;
};

#ifdef __cplusplus
extern "C"
{
#endif
SOCKET	NetLib_CreateClient(char * host, NetLib_CallbackProc Callback, DWORD flags, int default_port);
int		NetLib_SendString(NetLib_Connection * conn, char * str);
void	NetLib_SendXString(NetLib_Connection * conn, const char *fmt, ... );
#ifdef __cplusplus
}
#endif

#endif
