// 
// Online Game Cheats Irc Plugin
// Copyright (c) System   2002
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// In addition, as a special exception, the author gives permission to
// link the code of this program with the "Online Game Cheats client hook" 
// software (OGC hook) distributed on the main OGC site www.ogc-cheats.com. 
// You must obey the GNU General Public License in all respects for all 
// of the code used other than OGC hook.
// If you modify this file, you may extend this exception to your version of 
// the file, but you are not obligated to do so. If you do not wish to do so, 
// delete this exception statement from your version.

#ifdef _USRDLL
#define DLL_COMPILE
#endif

#include <stdio.h>
#include <windows.h>
#include <tchar.h>
#include <winsock.h>
#include "tinystrings.h"
#include "netlib.h"
#include <vector>
#include <algorithm>
#include "color.h"
void tintArea(int x, int y, int width, int height, ColorEntry *clr);
void glConsoleString(int x, int y, int r, int g, int b, char *string, ...);
void glText(int x, int y, int t, char *string,...);
using namespace std;

struct irccommand
{
	char* command;
	void(*commandfunc)(char* text);

};

void IrcInputParser(char* text);

#ifdef DLL_COMPILE
void(*echoCallBack)(char* text)=NULL;
void (*IrcNotify)(int notification)=NULL;
#else
void echoCallBack(char* text)
{
 printf("%s\n",text);
}

void IrcNotify(int notification)
{
	if (notification==3) {
		IrcInputParser("/join #cheat-network");
	}
}
#endif

void inline IrcError(char* text)
{
char buffer[512];
sprintf(buffer,"&x%s",text);
echoCallBack(buffer);
}

void inline IrcInfo(char* text)
{
char buffer[512];
sprintf(buffer,"&y%s",text);
echoCallBack(buffer);
}

char nick[MSL];
char id[8];

struct nicklist{
   char name[MSL];
};

struct channel{
	char name[MSL];
	bool active;
	char topic[MSL];
	vector<nicklist> nicks;
};
vector<channel> vChannels;


void	IrcEvent_PING(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
		NetLib_SendXString(conn, "PONG %s\r\n", str);
}

void	IrcEvent_NICK(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	if (!strlen(name)) return;
	if (!strcmpi(name,nick)) strcpy(nick,str);
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
             for (vector<nicklist>::iterator o = i->nicks.begin();o!=i->nicks.end();o++)
			 {
                 if (!strcmpi(o->name,name)) {
					 i->nicks.erase(o);
					 nicklist dummy;
			         memset(&dummy,0,sizeof(dummy));
                     strcpy(dummy.name,str);
			         i->nicks.push_back(dummy);
				 }
			 }
	char buffer[MSL];
	sprintf(buffer,"&b%s &rchanged nick to &b%s",name,str);
	IrcInfo(buffer);
	IrcNotify(2);
}

void IrcEvent_004(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	IrcNotify(3);
	TinyStrings_GetWord(nick,param,0);
	//MessageBox(0,name,str,0);
	//MessageBox(0,server,param,0);

}

void IrcEvent_PART(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	//MessageBox(0,name,str,0);
	//MessageBox(0,server,param,0);
	if (!strcmpi(name,nick))
	{
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
		if (!strcmpi(i->name,param)) { vChannels.erase(i); break; }
		IrcInputParser("/switch 1");
		IrcNotify(1);
		IrcNotify(0);
	}
	else
	{
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
		if (!strcmpi(i->name,param)) {
             for (vector<nicklist>::iterator o = i->nicks.begin();o!=i->nicks.end();o++)
			 {
                 if (!strcmpi(o->name,name)) {
					 i->nicks.erase(o);
					 break;
				 }
			 }
			 break;
		}
	}
	char buffer[MSL];
	sprintf(buffer,"&b%s &rleft &b%s",name,param);
	IrcInfo(buffer);
	IrcNotify(2);
}

void IrcEvent_Quit(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
             for (vector<nicklist>::iterator o = i->nicks.begin();o!=i->nicks.end();o++)
			 {
                 if (!strcmpi(o->name,name)) {
					 i->nicks.erase(o);
					 break;
				 }
			 }
	char buffer[MSL];
	sprintf(buffer,"&b%s &rquit &y<&b%s&y>",name,str);
	IrcInfo(buffer);
	IrcNotify(2);
}

void IrcEvent_KICK(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	char xchannel[MSL];
	TinyStrings_GetWord(xchannel,param,0);
	char xtarget[MSL];
    TinyStrings_GetWord(xtarget,param,1);
	//MessageBox(0,xtarget,xchannel,0);
	//MessageBox(0,param,str,0);
	if (!strcmpi(xtarget,nick))
	{
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
		if (!strcmpi(i->name,xchannel)) { vChannels.erase(i); break; }
		IrcInputParser("/switch 1");
		IrcNotify(0);
		IrcNotify(1);
	}
	else
	{
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
		if (!strcmpi(i->name,xchannel)) {
             for (vector<nicklist>::iterator o = i->nicks.begin();o!=i->nicks.end();o++)
			 {
                 if (!strcmpi(o->name,xtarget)) {
					 i->nicks.erase(o);
					 break;
				 }
			 }
			 break;
		}
	}
	char buffer[MSL];
	if (strlen(str))
	sprintf(buffer,"&b%s &rkicked &b%s%r from &b%s &r(&w%s&r)",name,xtarget,xchannel,str);
	else sprintf(buffer,"&b%s &rkicked &b%s%r from &b%s",name,xtarget,xchannel);
	IrcInfo(buffer);
	IrcNotify(2);
}

void IrcEvent_353(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	char buffer[MSL];
	TinyStrings_GetWord(buffer,param,2);
	//MessageBox(0,param,name,0);
	//MessageBox(0,str,server,0);

	for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
	if (!strcmpi(i->name,buffer)) 
	{
		DWORD count = TinyStrings_CountWords(str);
		for (DWORD o=0;o<count;o++)
		{
			nicklist dummy;
			memset(&dummy,0,sizeof(dummy));
			char orgdummynick[MSL];
			char *dummynick=orgdummynick;
			TinyStrings_GetWord(dummynick,str,o);
			if ((dummynick[0]=='@')||(dummynick[0]=='%')||(dummynick[0]=='+')) dummynick++;
            strcpy(dummy.name,dummynick);
			i->nicks.push_back(dummy);
		}
	}

}

void IrcEvent_366(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
  IrcNotify(2);
}
	

void IrcEvent_PRIVMSG(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
  bool active=false;
  for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
		if (!strcmpi(i->name,param)) { active=i->active; }
  char buffer[MSL];
  if (param[0]!='#' && param[0]!='&' && param[0]!='!')
  {
	  if (strlen(name))
  sprintf(buffer,"&b%s&r<private>&b: &w%s",name,str);
	  else sprintf(buffer,"&r<server>&b: &w%s",str);
  }
  else
  if (active)
  sprintf(buffer,"&b%s: &w%s",name,str);
  else sprintf(buffer,"&b%s&r<%s>&b: &w%s",name,param,str);
  IrcInfo(buffer);
}

void IrcEvent_JOIN(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	if (!strcmpi(name,nick))
	{
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
			if (!strcmpi(i->name,str)) { vChannels.erase(i); break; }
		for (i = vChannels.begin();i!=vChannels.end();i++)
			i->active=false;
		channel dummy;
		memset(dummy.topic,0,MSL);
		memset(dummy.name,0,MSL);
		dummy.active=true;
		strcpy(dummy.name,str);
		vChannels.push_back(dummy);
		IrcNotify(0);
		IrcNotify(1);
	}
	else
	{
		bool already=false;	
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
			if (!strcmpi(i->name,str)) { 
			already=true;
			break;
			}
		if (already) {
			nicklist dummy;
			memset(&dummy,0,sizeof(dummy));
            strcpy(dummy.name,name);
			i->nicks.push_back(dummy);
		}
	}
	char buffer[MSL];
	sprintf(buffer,"&b%s &rjoined &b%s",name,str);
	IrcInfo(buffer);
	IrcNotify(2);
}

void	IrcEvent_302(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
		char buffer[MSL];
		sprintf(buffer,"&bUser host:&r %s",	str);
		IrcInfo(buffer);

}
//==============================================================================
void	IrcEvent_303(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
		char buffer[MSL];
		sprintf(buffer,"&bIs On:&r %s",	str);
		IrcInfo(buffer);
}

void	IrcEvent_322(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
		char buffer[MSL];
		char buffer2[MSL];
		TinyStrings_GetWord(buffer2, param, 1);
		sprintf(buffer, "&%s:&r %s", buffer2, str);
		IrcInfo(buffer);
}

void	IrcEvent_352(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
char	buf1[MSL], buf2[MSL], buf3[MSL], buf4[MSL];
				
memset(buf1,0,MSL);
memset(buf2,0,MSL);
memset(buf3,0,MSL);
memset(buf4,0,MSL);
        TinyStrings_GetWord(buf1, param, 5);
		TinyStrings_GetWord(buf2,param, 2);
		TinyStrings_GetWord(buf3,param, 3);
		TinyStrings_GetWord(buf4,param, 4);

		char buffer[4*MSL];
		char buffer2[MSL];
		TinyStrings_GetWord(buffer2,str, 1);
		sprintf(buffer, "&b%s: &r%s@%s &bServer: &w%s, %s", 
				buf1,
				buf2,
				buf3,
				buf4,
				buffer2
				);
		IrcInfo(buffer);
}

// Who is user
void	IrcEvent_311(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
char	buf1[MSL], buf2[MSL];

        memset(buf1,0,MSL);
        memset(buf2,0,MSL);
        TinyStrings_GetWord(buf1,param, 1);
		TinyStrings_GetWord(buf2,param, 2);
		char buffer[2*MSL];

		char buffer3[MSL];
		TinyStrings_GetWord(buffer3,param, 3);
		sprintf(buffer, "&b%s: &r%s@%s: &w%s", 
				buf1,
				buf2,
				buffer3,
				str);
		IrcInfo(buffer);
}

void	IrcEvent_312(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	char buffer[MSL];	
	char buffer2[MSL];
	TinyStrings_GetWord(buffer2,param, 1);
	sprintf(buffer, "&bServerInfo:&r %s: %s", 
				buffer2,
				str);
	IrcInfo(buffer);
}
//==============================================================================
// Who is ops
void	IrcEvent_313(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
		char buffer[MSL];	
		char buffer2[MSL];
		TinyStrings_GetWord(buffer2,param, 1);
	sprintf(buffer, "&bServerInfo: &r%s: %s", 
				buffer2,
				str);
	IrcInfo(buffer);
}
//==============================================================================
// User is connecting...
void	IrcEvent_378(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
		char buffer[MSL];	
		char buffer2[MSL];
		TinyStrings_GetWord(buffer2,param, 1);
	sprintf(buffer, "&bUser &r%s %s", 
				buffer2,
				str);
	IrcInfo(buffer);
}
//==============================================================================
// User is connecting...
void	IrcEvent_319(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
		char buffer[MSL];	
		char buffer2[MSL];
TinyStrings_GetWord(buffer2,param, 1);
	sprintf(buffer, "&bUser &r%s&b is in:&w %s", 
				buffer2,
				str);
	IrcInfo(buffer);
}
// Channel topic
void	IrcEvent_332(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	char channelname[MSL];
	TinyStrings_GetWord(channelname,param, 1);
	for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
	{
		if (!strcmp(i->name,channelname)) {
			strcpy(i->topic,str);
			IrcNotify(0);
			break;
		}
	}
}

void	IrcEvent_TOPIC(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
	{
		if (!strcmp(i->name,param)) {
			strcpy(i->topic,str);
			IrcNotify(0);
			break;
		}
	}
	char buffer[MSL];
    sprintf(buffer, "&b%s %wset topic in %r%s &wto %b%s", name,param,str);
	IrcInfo(buffer);
}

void	IrcEvent_badnick(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	for(int i=0;i<10;i++){ nick[i] = 'a'+rand()%26; }
	NetLib_SendXString(conn, "NICK %s\r\n", nick);
}


typedef	void (* IrcEventHandler)(NetLib_Connection * conn, char * name, char * server, char * param, char * str);

struct	IrcEventStruct
{
char	* name;
IrcEventHandler	proc;
};
typedef	struct	IrcEventStruct	IrcEvent;

IrcEvent Events[] = {
	{"PING",&IrcEvent_PING},
	{"NICK",&IrcEvent_NICK},
	{"JOIN",&IrcEvent_JOIN},
	{"PART",&IrcEvent_PART},
	{"KICK",&IrcEvent_KICK},
	{"PRIVMSG",&IrcEvent_PRIVMSG},
	{"NOTICE",&IrcEvent_PRIVMSG},
	{"352",&IrcEvent_352},
	{"353",&IrcEvent_353},
    {"366",&IrcEvent_366},
	{"319",&IrcEvent_319},
	{"378",&IrcEvent_378},
	{"313",&IrcEvent_313},
	{"352",&IrcEvent_352},
	{"303",&IrcEvent_303},
	{"302",&IrcEvent_302},
	{"322",&IrcEvent_322},
	{"332",&IrcEvent_332},
    {"312",&IrcEvent_312},
	{"311",&IrcEvent_311},
	{"004",&IrcEvent_004},
	{"QUIT",&IrcEvent_Quit},
	{"433",&IrcEvent_badnick},
	{"432",&IrcEvent_badnick},
	{NULL,NULL},
};

void inline StripReturn(char * str)
{
	for(DWORD i=0;i<strlen(str);i++) if (str[i]==10 || str[i]==13) { str[i]=0x0;}
}

void	IrcEvent_GenericError(NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
	char buffer[MSL];
	if (strlen(param))
		sprintf(buffer,"%s: %s",TinyStrings_GetWordPointer(param,1), str);
	else
		sprintf(buffer,"%s", str);
	IrcError(buffer);
}

void	FindHandler(char * oper, NetLib_Connection * conn, char * name, char * server, char * param, char * str)
{
int		i, j;

		i = 0;

		if (isdigit(*oper)) {
			j = atoi(oper);
			if (j >= 400 && j <= 599)
			{
				IrcEvent_GenericError(conn, name, server, param, str);
				return;
			}
		}


		while (Events[i].name)
		{
			if (!_strcmpi(Events[i].name, oper))
				Events[i].proc(conn, name, server, param, str);
			i++;
		}
}

void	IrcParseString(NetLib_Connection * conn, char * str)
{
char	cmd[MSL];
char	name[MSL];
char	server[MSL];
char	param[MSL];
char	info[MSL];
char	* c, * t;
		
		StripReturn(str);
		//IrcInfo(str);
		c = str;
		if (!*c) return;
		memset(cmd,0,MSL);
        memset(name,0,MSL);
		memset(server,0,MSL);
		memset(param,0,MSL);
		memset(info,0,MSL);
	 TinyStrings_GetWord(name,str, 0);

		if (name[0] != ':') 
		{
				strncpy(cmd, name, MSL);
				strncpy(info, TinyStrings_GetWordPointer(str, 1)+1, MSL);
		} else
		{
				strncpy(name, name+1, MSL);

				c = name;
				while (*c && *c != '!') c++;
				if (*c) {
					strncpy(server, c + 1, MSL);
					*c = 0;
				} else
				{
					strncpy(server, name, MSL);
					name[0] = '\0';
				}

				TinyStrings_GetWord(cmd, str, 1);
				c = TinyStrings_GetWordPointer(str, 2);
				t = strchr(c,':');
				if (t)
				{
					//MessageBox(0,c,0,0);
					glText(255,255,28,c);
					strncpy(param,c,t-c);
					if (param[t-c-1]==' ') param[t-c-1]=0x0;
					//MessageBox(0,param,t,0);
					strcpy(info,t+1);
				}
				else
				strcpy(param,c);
					/*MessageBox(0,c,0,0);
				if (*c != ':')
				{
					while (*c && *c != ':') c++;
					c--;					
					strncpy(param, t, (int)(c-t));
					c += 2;
				} else
				{
					param[0] = '\0';
					c++;
				}
				MessageBox(0,param,0,0);

				info[0] = '\0';
				if (*c) strncpy(info, c, MSL);
				MessageBox(0,info,0,0);*/
		}

		FindHandler(cmd, conn, name, server, param, info);
}

NetLib_Connection* globalconn=NULL;
int	IrcCallback(NetLib_Connection * conn, int reason, void * data, int len)
{
		switch (reason)
		{
		case NETLIB_REASON_INITIALIZE:
			break;
		case NETLIB_REASON_CONNECT:
			globalconn=conn;
			vChannels.clear();
			IrcInfo("Connected to IRC server...");
			NetLib_SendXString(conn, "NICK %s\r\n", nick);
			NetLib_SendXString(conn, "USER %s 0 * :%s\r\n\r\n", id, "OGC IRC Client (www.system.cd)");
			IrcNotify(2);
			IrcNotify(1);
			IrcNotify(0);
			break;
		case NETLIB_REASON_CONNECTION_FAILED:
			IrcError("IRC Connection failed.");
			break;
		case NETLIB_REASON_DISCONNECT:
			globalconn=NULL;
			vChannels.clear();
			IrcNotify(1);
			IrcNotify(2);
			IrcNotify(0);
			IrcInfo("IRC Connection closed.");
			break;
		case NETLIB_REASON_DATA:
			IrcParseString(conn, (char *)data);
			break;
		}

		return 0;
}

void IRCCMD_connect(char* text)
{
	int wordcount = TinyStrings_CountWords(text);
	if (wordcount!=1) { IrcError("Usage: /server <ircserver>(:<port>)"); return; }
	if (globalconn) 
	{
		NetLib_SendXString(globalconn, "QUIT :%s\r\n", "OGC IRC CLIENT");
		globalconn->active=false;
	}
	char server[MSL];
	TinyStrings_GetWord(server,text,0);
    NetLib_CreateClient(server, IrcCallback, TCP_FLAG_TEXT, 6667);
}

void IRCCMD_nick(char* text)
{
	int wordcount = TinyStrings_CountWords(text);
	if (wordcount!=1) { IrcError("Usage: /nick <nickname>"); return; }
	if (globalconn) 
	{
		NetLib_SendXString(globalconn, "NICK %s\r\n",text);
	}
	else strcpy(nick,text);
}

void IRCCMD_join(char* text)
{
	int wordcount = TinyStrings_CountWords(text);
	if (wordcount<1) { IrcError("Usage: /join <channel>"); return; }
	if (globalconn) 
	{
		NetLib_SendXString(globalconn, "JOIN %s\r\n",text);
	}
}

void	IRCCMD_mode(char * arg)
{
		if (!globalconn) return; 
		if (TinyStrings_CountWords(arg) < 2)
		{
			IrcError("Usage: /mode <channel/nickname> <mode string>");
			return;
		}
		NetLib_SendXString(globalconn, "MODE %s\r\n", arg);
}
void IRCCMD_part(char* text)
{
	int wordcount = TinyStrings_CountWords(text);
	if (wordcount<1) { 
	for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
	{
		if (i->active)
		{
			NetLib_SendXString(globalconn, "PART %s\r\n",i->name);
			return;
		}
	}
	IrcError("Usage: /part <channel>"); 
	}
	else
	if (globalconn) 
	{
		if (wordcount==1)
		NetLib_SendXString(globalconn, "PART %s\r\n",text);
		else
		{
			char buffer3[MSL];
          TinyStrings_GetWord(buffer3,text,0);
		  NetLib_SendXString(globalconn, "PART %s :%s\r\n",buffer3,TinyStrings_GetWordPointer(text,1));	
		}
	}
}

void IRCCMD_whois(char* text)
{
	int wordcount = TinyStrings_CountWords(text);
	if (wordcount!=1) { IrcError("Usage: /whois <nickname>"); return; }
	if (globalconn) 
	{
		NetLib_SendXString(globalconn, "WHOIS %s\r\n",text);
	}
}

void IRCCMD_switch(char* text)
{
	int wordcount = TinyStrings_CountWords(text);
	if (wordcount>1) { IrcError("Usage: /switch (<#>)"); return; }
	if (wordcount==0) { 
	char buffer[MSL];
	memset(buffer,0,MSL);
	int x=0;
	for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
	{
		char inbuffer[MSL];
	    x++;
        if (!i->active)
		sprintf(inbuffer,"&y(%i)&x %s ",x,i->name);
		else sprintf(inbuffer,"&y(%i)&r %s ",x,i->name);
		strcat(buffer,inbuffer);
	}
	IrcInfo(buffer);
	}
	else
	{
		int x=0;
		int number = atoi(text);
		bool inchannel=false;
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
		{
			x++;
			i->active=(x==number);
			if (x==number)
			{
			char buffer[MSL];
			sprintf(buffer,"current channel/query: &r%s",i->name);
			inchannel=true;
			IrcInfo(buffer);
			}
		}
		if (!inchannel) IrcInfo("no channel/query active");
	}
	IrcNotify(0);
	IrcNotify(1);
	IrcNotify(2);
}

void IRCCMD_quit(char* text)
{
	if (globalconn) 
	{
		if (strcmp(text,""))
		NetLib_SendXString(globalconn, "QUIT :%s\r\n", text);
		else NetLib_SendXString(globalconn, "QUIT :%s\r\n", "OGC IRC CLIENT");
		globalconn->active=false;
	}
}

void IRCCMD_raw(char* text)
{
	if (globalconn) 
	{
		NetLib_SendXString(globalconn, "%s\r\n", text);
	}
}

void IRCCMD_msg(char* text)
{
	int wordcount = TinyStrings_CountWords(text);
	if (wordcount<2) { IrcError("Usage: /msg <channel/nickname> <text>"); return; }
	if (globalconn) 
	{
		char buffer[MSL];
		char buffer3[MSL];
		TinyStrings_GetWord(buffer3,text,0);
		NetLib_SendXString(globalconn, "PRIVMSG %s :%s\r\n", buffer3,TinyStrings_GetWordPointer(text,1));
		char buffer2[MSL];
        TinyStrings_GetWord(buffer2,text,0);
		sprintf(buffer,"&b%s&r->&b: &w%s",nick,buffer2,TinyStrings_GetWordPointer(text,1));
        IrcInfo(buffer);
	}
}

void IRCCMD_notice(char* text)
{
	int wordcount = TinyStrings_CountWords(text);
	if (wordcount<2) { IrcError("Usage: /notice <channel/nickname> <text>"); return; }
	if (globalconn) 
	{
		char buffer[MSL];
        TinyStrings_GetWord(buffer,text,0);
		NetLib_SendXString(globalconn, "NOTICE %s :%s\r\n", buffer,TinyStrings_GetWordPointer(text,1));
	}
}


struct irccommand irccommands[] ={
	{"connect",&IRCCMD_connect},
	{"server",&IRCCMD_connect},
	{"quit",&IRCCMD_quit},
	{"logoff",&IRCCMD_quit},
	{"exit",&IRCCMD_quit},
	{"nick",&IRCCMD_nick},
	{"join",&IRCCMD_join},
	{"part",&IRCCMD_part},
	{"leave",&IRCCMD_part},
	{"switch",&IRCCMD_switch},
	{"raw",&IRCCMD_raw},
	{"quote",&IRCCMD_raw},
	{"msg",&IRCCMD_msg},
	{"mode",&IRCCMD_mode},
	{"notice",&IRCCMD_notice},
	{"whois",&IRCCMD_whois},
};

void IrcInputParser(char* text)
{
  int wordcount = TinyStrings_CountWords(text);
  if (wordcount)
  {
     if (*text=='/')
	 {
	  char buffer[MSL];
	  char* commandname=buffer;
	  TinyStrings_GetWord(commandname,text,0);
	  strlwr(commandname);
	  commandname++;
	  for (int i=0;i<(sizeof(irccommands)/sizeof(irccommand));i++)
          if (!strcmp(commandname,irccommands[i].command))
		  {
			  if (wordcount>1)
			  irccommands[i].commandfunc(text+strlen(commandname)+2);
			  else irccommands[i].commandfunc(text+strlen(commandname)+1);
			  return;
		  }
	  IrcError("unknown command");
     }
	 else
	 {
		 for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
		 {
			if (i->active)
			{
				NetLib_SendXString(globalconn, "PRIVMSG %s :%s\r\n",i->name,text);
			    char buffer[MSL];
				sprintf(buffer,"&b%s: &w%s",nick,text);
                IrcInfo(buffer);
				return;
			}
		 }
		IRCCMD_raw(text);
	 }
  }
  else IrcError("empty input string");
}

#ifdef DLL_COMPILE
extern "C"{
vector<nicklist>::iterator nicker;
vector<nicklist>::iterator endnicker;


bool NickCompare(
const nicklist& x, const nicklist& y) {
return (strcmpi(x.name,y.name) < 0);
}

__declspec(dllexport) char* IrcGetFirstUser()
{
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
	       if (i->active)
		   {
			   sort(i->nicks.begin(), i->nicks.end(),NickCompare);
			   nicker=i->nicks.begin();
			   endnicker=i->nicks.end();
			   if (nicker!=endnicker)
			   return nicker->name;
			   break;
		   }
   return NULL;

}
__declspec(dllexport) char* IrcGetNextUser()
{
	nicker++; if (nicker!=endnicker) return nicker->name;
	else return NULL;

}
__declspec(dllexport) char* IrcGetBottomLine()
{
  	static char buffer[MSL];
	memset(buffer,0,MSL);
	int x=0;
	if (vChannels.empty()) return NULL;
	for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
	{
		char inbuffer[MSL];
	    x++;
        if (!i->active)
		sprintf(inbuffer,"&y(%i)&x %s ",x,i->name);
		else sprintf(inbuffer,"&y(%i)&r %s ",x,i->name);
		strcat(buffer,inbuffer);
	}
	return buffer;
}
__declspec(dllexport) char* IrcGetTopLine()
{
static char buffer[MSL];
if (!globalconn) return "Status - offline";
		for (vector<channel>::iterator i = vChannels.begin();i!=vChannels.end();i++)
	       if (i->active)
		   {
			   sprintf(buffer,"&y%s %s",i->name,i->topic);
			   return buffer;
		   }
return "Status - online";
}
__declspec(dllexport) void IrcSubmit( char* text )
{
  IrcInputParser(text);
}
__declspec(dllexport) int IrcInitialize( void(*gechoCallBack)(char* text), void (*gIrcNotify)(int notification) )
	{
		echoCallBack = gechoCallBack;
		IrcNotify = gIrcNotify;
		echoCallBack( "plugin_irc.dll: loaded." );
		IrcNotify(0);
		IrcNotify(1);
		IrcNotify(2);
		return 0;
	}
}

BOOL APIENTRY DllMain(HANDLE hModule,DWORD ul_reason_for_call,LPVOID lpReserved)
	{
		switch(ul_reason_for_call)
		{
		case DLL_PROCESS_ATTACH:
			{
			memset(nick,0,MSL);
			srand(GetTickCount());
			for(int i=0;i<10;i++){ nick[i] = 'a'+rand()%26; }
			memset(id,0,8);
			for(i=0;i<7;i++){ id[i] = 'a'+rand()%26; }
			break;
			}
		case DLL_PROCESS_DETACH:
			{
            IRCCMD_quit("");
			break;
			}
		}
		return TRUE;
	}
#else
	int _tmain(int argc, _TCHAR* argv[])
	{
		memset(nick,0,MSL);
		srand(GetTickCount());
		for(int i=0;i<10;i++){ nick[i] = 'a'+rand()%26; }
		memset(id,0,8);
		for(i=0;i<7;i++){ id[i] = 'a'+rand()%26; }
		IrcInputParser("/server irc.rizenet.org");
		while (true) {	
			char buffer[1024];
			gets(buffer);
			IrcInputParser(buffer);
		}
		return 0;
	}
#endif

