// 
// Online Game Cheats Client.dll hook
// Copyright (c) system   2001-2002
// Copyright (c) bunny771 2001-2002
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// NOTE:
// GNU license doesn't cover Engine directory.
// Content of Engine directory is copyrighted (c) 1999, 2000, by Valve LLC
// and it is licensed under Valve's proprietary license (see original HL SDK).
// 

#include <stdio.h>
#include "cvar.h"
#include "interpreter.h"
#include "winamp.h"

// Global for your CVARs
CVARlist cvar;

//=======================================================================================
void CVARlist::init()
{ 
	// default all cvars to 0
	memset((char*)this, 0, sizeof(*this)); 

	#define REGISTER_CVAR_FLOAT(name,defaultvalue) cmd.AddCvarFloat(#name, &##name );name=defaultvalue##f;
	REGISTER_CVAR_FLOAT( pointsize	,4.0)
	REGISTER_CVAR_FLOAT( linewidth	,2.0)
//	REGISTER_CVAR_FLOAT( zoomfov	,55.0)
	REGISTER_CVAR_FLOAT( speed		,1.0) 
	REGISTER_CVAR_FLOAT( aspeed		,1.0)
	REGISTER_CVAR_FLOAT( wa_fadeinspeed, 0.015)
	REGISTER_CVAR_FLOAT( soundtime ,2.00)
	REGISTER_CVAR_FLOAT( wa_fadeoutspeed, 0.005 )
	REGISTER_CVAR_FLOAT( hl_vol1     ,   0.2 ) 
	REGISTER_CVAR_FLOAT( hl_vol2     ,   0.7 )

	#define REGISTER_CVAR_INT(name,defaultvalue) cmd.AddCvarInt(#name, &##name );name=defaultvalue;
	REGISTER_CVAR_INT( wall			,2)
	REGISTER_CVAR_INT( wallmode		,0)
	REGISTER_CVAR_INT( wallfix		,0)
	REGISTER_CVAR_INT( trans		,128)
	REGISTER_CVAR_INT( lambert		,1)
	REGISTER_CVAR_INT( fullbright	,0)
	REGISTER_CVAR_INT( flash		,1)
	REGISTER_CVAR_INT( smoke		,1)
	REGISTER_CVAR_INT( sky			,0)
	REGISTER_CVAR_INT( tconsole		,0)
	REGISTER_CVAR_INT( wire			,0)

	REGISTER_CVAR_INT( aim			,1)
	REGISTER_CVAR_INT( mode			,0)
	REGISTER_CVAR_INT( avdraw		,1)
	REGISTER_CVAR_INT( esp			,5)
	REGISTER_CVAR_INT( espmode		,1)

	REGISTER_CVAR_INT( hud			,1)
	REGISTER_CVAR_INT( colred		,0)
	REGISTER_CVAR_INT( status		,1)
	REGISTER_CVAR_INT( smartaiming	,1)
	REGISTER_CVAR_INT( throughwalls	,0)
	REGISTER_CVAR_INT( randomoff	,0)
	REGISTER_CVAR_INT( teaminfo		,0)
	REGISTER_CVAR_INT( showdistance	,0)
	REGISTER_CVAR_INT( verticeinfo	,0)
	REGISTER_CVAR_INT( unknown		,0)
	REGISTER_CVAR_INT( fov			,210)
	REGISTER_CVAR_INT( aimatunknown	,0)
//	REGISTER_CVAR_INT( iAimAt		,1)
	REGISTER_CVAR_INT( offset		,-5)
	REGISTER_CVAR_INT( duckoffset	,3)
	REGISTER_CVAR_INT( aimatdead	,0)
	REGISTER_CVAR_INT( mytarget		,0)
	REGISTER_CVAR_INT( gmode		,0)
	REGISTER_CVAR_INT( cross		,8)
	REGISTER_CVAR_INT( shoot		,0)
	REGISTER_CVAR_INT( fog			,0)

	REGISTER_CVAR_INT( menu_x		,240)
	REGISTER_CVAR_INT( menu_y		,240)
	REGISTER_CVAR_INT( menu_w		,160)
	REGISTER_CVAR_INT( con_h		,600) 
	REGISTER_CVAR_INT( con_y		,0)
	REGISTER_CVAR_INT( con_w		,524)
	REGISTER_CVAR_INT( con_x		,500)
	REGISTER_CVAR_INT( con_slidespeed,5)

	REGISTER_CVAR_INT( status_x		,20)
	REGISTER_CVAR_INT( status_y		,600)
	REGISTER_CVAR_INT( status_z		,0)
	REGISTER_CVAR_INT( info			,1)
	REGISTER_CVAR_INT( debug		,0)
	REGISTER_CVAR_INT( shadow		,0)
	REGISTER_CVAR_INT( espoffs		,1)
	REGISTER_CVAR_INT( espoffset	,0)
	REGISTER_CVAR_INT( stripple		,0)
	REGISTER_CVAR_INT( speedoff		,5000) 
	REGISTER_CVAR_INT( speedon		,1000)
	REGISTER_CVAR_INT( dead			,0)
	REGISTER_CVAR_INT( segments		,15)
	REGISTER_CVAR_INT( blood		,0)
//	REGISTER_CVAR_INT( sec_dump		,0)// fix
	REGISTER_CVAR_INT( text_background,1)
	REGISTER_CVAR_INT( alive_method	,0)
	REGISTER_CVAR_INT( death		,1)
	REGISTER_CVAR_INT( sglow		,1)
	REGISTER_CVAR_INT( tglow		,1)
	REGISTER_CVAR_INT( saystats		,1)
	REGISTER_CVAR_INT( sniper		,1)
	REGISTER_CVAR_INT( inpvs		,100)
	REGISTER_CVAR_INT( box			,2)
	REGISTER_CVAR_INT( esp_offs		,1)
	REGISTER_CVAR_INT( esp_wrap		,1)
	REGISTER_CVAR_INT( esp_line		,1)
	REGISTER_CVAR_INT( weapon		,1)
	REGISTER_CVAR_INT( distance		,1)
	REGISTER_CVAR_INT( name			,1)
	REGISTER_CVAR_INT( reload		,1)
	REGISTER_CVAR_INT( radar		,1)
	REGISTER_CVAR_INT( antizoom		,1)
	REGISTER_CVAR_INT( confont		,0)
	REGISTER_CVAR_INT( glow			,1)
	REGISTER_CVAR_INT( spiked		,0)
	REGISTER_CVAR_INT( barrel		,0)
	REGISTER_CVAR_INT( bombtimer	,1)
	REGISTER_CVAR_INT( team			,0)
	REGISTER_CVAR_INT( czoom		,0)
	REGISTER_CVAR_INT( spikedmode	,1)
	REGISTER_CVAR_INT( sparkler		,0)
	REGISTER_CVAR_INT( lambertglow	,0)
	REGISTER_CVAR_INT( sparklerheight,20)
	REGISTER_CVAR_INT( ignore		,0)
	REGISTER_CVAR_INT( friendlyesp	,1)
	REGISTER_CVAR_INT( thirdperson	,0)
	REGISTER_CVAR_INT( esp_background,0)
	REGISTER_CVAR_INT( wa_autovolume,1)
	REGISTER_CVAR_INT( wa_active  ,1)
	REGISTER_CVAR_INT( wa_vol2  ,255)
	REGISTER_CVAR_INT( wa_vol1  ,0)
	REGISTER_CVAR_INT( wa_title, 1);

	cvar.init_cmd();
}
