#include	<windows.h>
#include	<stdio.h>
#define	MSL	1024

//
// TinyStrings functions by Plastique:
//

//---------------------------------------------------------
int	TinyStrings_CountWords(char * cmd_arg)
{
char	* j;
int		count = 0;

		if (!cmd_arg) return 0;

		j = cmd_arg;

		while (*j) {
			
			// Skip spaces
			while (*j && isspace(*j)) j++;

			if (!*j) break;

			count++;
			while (*j && !isspace(*j)) j++;
		}
		return count;
}

//---------------------------------------------------------
char *	TinyStrings_GetWord(char * temp,char * cmd_arg, int number)
{
char	* j, *i;
int		count = 0;
         
		if (!cmd_arg) return NULL;
        memset(temp,0,MSL);
		j = cmd_arg;

		if (number >= TinyStrings_CountWords(cmd_arg)) return "";

		i = temp;
		*i = 0;

		while (*j) {
			// Skip spaces
			while (*j && isspace(*j)) j++;

			if (count == number) {
				while (*j && !isspace(*j)) *(i++) = *(j++);
				*i = 0;
				return temp;
			}

			count++;
			while (*j && !isspace(*j)) j++;
		}
		return "";
}
//---------------------------------------------------------
char *	TinyStrings_GetWordPointer(char * cmd_arg, int number)
{
char	* j;
int		count = 0;

		if (!cmd_arg) return NULL;

		j = cmd_arg;

		if (number >= TinyStrings_CountWords(cmd_arg)) return "";

		while (*j) {
			// Skip spaces
			while (*j && isspace(*j)) j++;

			if (count == number) return j;

			count++;
			while (*j && !isspace(*j)) j++;
		}
		return "";
}
